Interface/NIC compute attributes in APl host creation overwritten with compute profile attributes
03/14/2016 06:48 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Host creation

Target version:

1.11.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/3316
Description

Since #6342, compute attributes specified inside a NIC/interface via the host create API are overwritten with compute attributes from
associated compute profiles. This has the same symptoms as ticket #11124, which fixed it before #6342 reintroduced it.

POST to /api/v2/hosts with the following parameters:

{
"host": {
"name": "niccrattrs",
"libvirt",
"localhost",

"hostgroup_name":
"compute_resource_name":
"compute_attributes": {
"cpus": 3
}I
"interfaces_attributes": {
"o": |
"primary":
"compute_attributes": {
"model": "elO0O"

"true",

}

}

... results in a VM with the NIC model set in the compute profile assigned to the host group, rather than e1000 as per the NIC
compute attributes.

In HostsController#create, the host compute attrs after ComputeAttributeMerge contains the nic_attributes from the profile:

[1] pry (#<Api::V2::HostsController>)> @host.compute_attributes
=> {"cpus"=>3,
"memory"=>"1073741824",
"nics_attributes"=>{"0"=>{"type"=>"network",
"volumes_attributes"=>{"0"=>{"pool_name"=>"default",
at_type"=>"qcow2"}}}

"network"=>"default",
"capacity"=>"10G",

"model"=>"virtio"}},

"allocation"=>"0G", "form

Prior to #6342, these compute attributes wouldn't have been filled in - it changed the APl behaviour to merge compute profile
attributes into host.compute_attributes.

But the NIC's compute_attributes does contain the merged compute attributes from the compute profile plus the user's parameters,
due to InterfaceMerge and #11124:

[2] pry (#<Api::V2::HostsController>)> @host.interfaces

=> [#<Nic::Managed id: nil, mac: nil, ip: nil, type: "Nic::Managed", name: "test13982a", host_id:

nil, subnet_id: nil, domain_id: nil, attrs: {}, created_at: nil, updated_at: nil, provider: nil, u
sername: nil, password: nil, virtual: false, link: true, identifier: nil, tag: "", attached_to: ""
, managed: true, mode: "balance-rr", attached_devices: "", bond_options: "", primary: true, provis
ion: true, compute_attributes: {"type"=>"network", "network"=>"default", "model"=>"el000", "from_p
rofile"=>"1ibvirt"}>]

Later in Orchestration::Compute#add_interfaces_to_compute_attrs, the per-NIC compute attributes should be merged back into the
host compute attributes, but the step is skipped (the return unless in this method) as the host compute attributes already contains
nics_attributes:

[1] pry (#<Host::Managed>)> compute_attributes|[attrs_name]
=> {"0"=>{"type"=>"network", "network"=>"default", "model"=>"virtio"}}
[2] pry (#<Host::Managed>)> compute_attributes
=> {"cpus"=>3,
"memory"=>"1073741824",
"nics_attributes"=>{"0"=>{"type"=>"network", "network"=>"default", "model"=>"virtio"}},
"volumes_attributes"=>{"0"=>{"pool_name"=>"default", "capacity"=>"10G", "allocation"=>"0G", "form
at_type"=>"gcow2"}}}

Related issues:
Related to Foreman - Bug #6342: Compute profile should be used when empty vol... Closed 06/23/2014
Related to Foreman - Bug #11124: Interface compute attributes not merged from... Closed 07/15/2015

Associated revisions

Revision 860cbb0a - 03/14/2016 02:53 PM - Dominic Cleal
fixes #14179 - don't merge NIC compute attrs in ComputeProfileMerge

When creating a host over the API and specifying interface compute
attributes, the interface attributes were overwritten from the compute
profile. Example request:

{"host":{"interfaces_attributes":{"0":{"primary":"true", "compute_attributes":{"model":"el000"}}}, ...}}

ComputeProfileMerge stores :interfaces_attributes (name varies based on
the CR type) from the profile in host.compute_attributes, while
InterfaceMerge stores attributes in each interface. When
Orchestration::Compute#add_interfaces_to_compute_attrs runs to merge
per-interface attributes into host.compute_attributes, the step was
skipped as host.compute_attributes[:interfaces_attributes] already

existed from ComputeProfileMerge.

This change excludes interface attributes from being merged by
ComputeProfileMerge, so InterfaceMerge is responsible for copying them
into the interface.

Revision ff222ae6 - 03/22/2016 01:15 PM - Dominic Cleal
fixes #14179 - don't merge NIC compute attrs in ComputeProfileMerge

When creating a host over the API and specifying interface compute
attributes, the interface attributes were overwritten from the compute
profile. Example request:

{"host":{"interfaces_attributes":{"0":{"primary":"true", "compute_attributes":{"model":"el000"}}}, ...}}

ComputeProfileMerge stores :interfaces_attributes (name varies based on
the CR type) from the profile in host.compute_attributes, while
InterfaceMerge stores attributes in each interface. When
Orchestration::Compute#add_interfaces_to_compute_attrs runs to merge
per-interface attributes into host.compute_attributes, the step was
skipped as host.compute_attributes[:interfaces_attributes] already

existed from ComputeProfileMerge.

This change excludes interface attributes from being merged by
ComputeProfileMerge, so InterfaceMerge is responsible for copying them
into the interface.

(cherry picked from commit 860cbb0a7c86f7669aad75c7011dbb2030aaede0)

History

#1 - 03/14/2016 06:48 AM - Dominic Cleal
- Related to Bug #6342: Compute profile should be used when empty volumes and interfaces passed in compute_attributes added

#2 - 03/14/2016 06:48 AM - Dominic Cleal

- Related to Bug #11124: Interface compute attributes not merged from API request over compute profile added

#3 - 03/14/2016 07:00 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#4 - 03/14/2016 08:08 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3316 added

#5 - 03/14/2016 03:02 PM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 860cbb0a7c86f7669aad75¢7011dbb2030aaede0.
